//Online documentation search functions
//Omnis Software Ltd 2020

var qsParm = new Array();

var tocHiLite; // toc a element currently hilighted
var searchTerm; //searchterm passed as part of the url, e.g. from search.jsp

function splitParams()
{
	var query = window.location.search.substring(1) +  window.location.hash;
	var parms = query.split('&');
	qsParm['detail'] = null;
	for (var i=0; i<parms.length; i++)
	{
		var pos = parms[i].indexOf('=');
		if (pos > 0)
		{
				var key = parms[i].substring(0,pos);
				var val = parms[i].substring(pos+1);
				qsParm[key] = val;
		}
	}
}

/*If specified, load a page into the content frame and expand the TOC to show it*/
function maybeLoadContent() {

	splitParams();
	var url = qsParm['detail'] || '';
	searchTerm = qsParm['search'] || '';
	var isScrolling; //used to detect scrolling content
	if (url)
	{
			var a =  document.getElementById("contentFRM");
			a.onload = function () {
				showTocHiLite(url);
				a.contentWindow.addEventListener('scroll', function ( event ) {
					//Detect when scrolling ends on the content frame so that TOC cursor can be repositioned
					window.clearTimeout( isScrolling );
					isScrolling = setTimeout(function() {
						showTocHiLite(url);
					}, 66);
				}, false);
			};

			a.src = url;

			var hashstart = url.indexOf("#");
			var hashTag = url.substring(hashstart,200);
			var tocFrame = document.getElementById("tocFRM");
			tocFrame.contentWindow.expandTOC(hashTag);
	}
}

function getListDepth(elem) { 
var depth = 0;
while (elem) {
		if (elem.nodeName == "LI") depth += 1;
		elem = elem.parentNode;
}
return depth;
}

	/*Expand the toc to display the supplied anchor name*/
	function expandTOC(anchorName) {
	var elem = getElementByAnchorName(anchorName); //e.g. #cookie-and-referer-headers
	var depth = getListDepth(elem);
	if (depth==1){
		//expand parent.li
		elem = CollapsibleLists.parentLi(elem);
		CollapsibleLists.expandLi(elem);
	} else if (depth==2) {
		//expand parent.li
		elem = CollapsibleLists.parentLi(elem);
		CollapsibleLists.expandLi(elem);
		//expand parent.li.parent.li
		elem = CollapsibleLists.parentLi(elem.parentNode);
		CollapsibleLists.expandLi(elem);
	} else {//depth==3
		//expand parent.li.parent.li
		elem = CollapsibleLists.parentLi(elem);
		if (!elem) return;
		elem = CollapsibleLists.parentLi(elem.parentNode);
		CollapsibleLists.expandLi(elem);
		elem = CollapsibleLists.parentLi(elem.parentNode);
		CollapsibleLists.expandLi(elem);
	}
  }


/*find an  a tag that contains the supplied anchor name*/
function getElementByAnchorName(anchorName) {
	var aTags = document.getElementsByTagName("a");
	var found;

	for (var i = 0; i < aTags.length; i++) {
		var hashtag = aTags[i].hash.substring(0, aTags[i].hash.length-2);
		if (hashtag == null || hashtag.length == 0) {
			var hashpos =  aTags[i].href.indexOf("#");
			hashtag = aTags[i].href.substring(hashpos, aTags[i].href.length-2);
		}
		
		 if (hashtag == anchorName) {
			found = aTags[i];
			break;
		}
	}
	return found;
}

function addHitCount(elem, hitCount) {
	if (elem.parentNode.firstChild.className=="hitcount")
			return; //a duplicate hashtag may exist, ignore this for now
			
	var newCb = document.createElement('div');
	newCb.className = "hitcount";
	newCb.innerHTML = hitCount>=20? "20+" : hitCount;
	elem.parentNode.insertBefore(newCb, elem);
}

/*Collapse the toc completely*/
function collapseTOC() {
	var tocFrame = document.getElementById("tocFRM");
		
	var checkBoxes = tocFrame.contentWindow.document.querySelectorAll('.collapsiblelistOpen'); 
	for (var i = 0; i < checkBoxes.length; i++) {
			CollapsibleLists.toggleLi(checkBoxes[i]);  
	}
}


function search0() {
	document.getElementById("searchButton").src =  "/images/wait20.gif"; //set wait icon

	clearHitCounters(); 
	collapseTOC();

	var searchTerm = encodeURI(document.getElementById("searchTerm").value);

	var x=new XMLHttpRequest();
	//This GET HTTP request is currently submitted to an Omnis instance running on the localhost.
	//Please modify the URL and/or serverport as necessary.
	x.open("GET", "http://127.0.0.1/omnisrest/ws/7000/api/sitesearch/sitesearch/docs?term=" + searchTerm , true);
	
	x.onload=function(e){
			document.getElementById("searchButton").src = "/images/search.png";  // clear wait icon
			var resultArray = JSON.parse(x.response);

			var tocFrame = document.getElementById("tocFRM");
			collapseTOC();
			var urlList = Array.from(tocFrame.contentDocument.getElementsByTagName("A"));

			var firstHit = null; //store the first element (scroll to it later)
			for (var a=0; a<resultArray.length; a++) {
				var foundUrl = urlList.find(function(thisUrl) {
					if (thisUrl.href.indexOf(resultArray[a].newUrl) >= 0)  // +"'"
						return thisUrl;
					return null;
				});
			

			if (foundUrl) {
				if (!firstHit) 
					firstHit = foundUrl; //urlList[a];
				var depth = getListDepth(foundUrl) - 1;
				var elem = foundUrl;
				if (depth==1){
						//expand parent.li
						elem = CollapsibleLists.parentLi(elem);
						CollapsibleLists.expandLi(elem);
				} else if (depth==2) {
						//expand parent.li
						elem = CollapsibleLists.parentLi(elem);
						CollapsibleLists.expandLi(elem);
						//expand parent.li.parent.li
						elem = CollapsibleLists.parentLi(elem.parentNode);
						CollapsibleLists.expandLi(elem);
				} else {//depth==3
						elem = CollapsibleLists.parentLi(elem);
						elem = CollapsibleLists.parentLi(elem.parentNode);
						CollapsibleLists.expandLi(elem);
						elem = CollapsibleLists.parentLi(elem.parentNode);
						CollapsibleLists.expandLi(elem);
				}

				addHitCount(foundUrl,resultArray[a].qty);
			}
		}
		if (firstHit) {
			firstHit.scrollIntoView({behavior: "smooth", block: "end", inline: "nearest"});	
		}
		else {
			setPlaceholder(document.getElementById("searchTerm").value+ " not found");
			document.getElementById("searchTerm").value="";
		}
	}

	x.send();
}


//When "X" is pressed, clear hit counter and collapse the TOC tree list
function cancelSearch() {
	clearHitCounters(); 
	document.getElementById('searchTerm').value = ''; 
	collapseTOC();
	setPlaceholder("Search this manual");
	document.getElementById("searchButton").src =  "/images/search.png"; //set wait icon
}

//Remove all "hitcount" div elements from the toc and remove highlighting from the content document
function clearHitCounters(){
	var tocFrame = document.getElementById("tocFRM");
	var elements = tocFrame.contentDocument.getElementsByClassName("hitcount");
	while(elements.length > 0){
			elements[0].parentNode.removeChild(elements[0]);
	}

	var iframe = document.getElementById("contentFRM");
	var iframeDocument = iframe.contentDocument || iframe.contentWindow.document;
	var myHilitor = new Hilitor(iframeDocument.body);
	myHilitor.remove(iframeDocument);

}

//Detect enter key press inside the search field
$(document).keyup(function (e) {
	if ($(".searchField:focus") && (e.keyCode === 13)) {
			search0();
	}
});

//Copy page link to clipboard
function pageLinkToClipboard() {
	var dummy = document.createElement("input");
	document.body.appendChild(dummy);
	dummy.setAttribute("id", "dummy_id");
	document.getElementById("dummy_id").value=currentPage;
	dummy.select();
	document.execCommand("copy");
	document.body.removeChild(dummy);

	var tooltip = document.getElementById("myTooltip");
	tooltip.innerHTML="Copied to clipboard";
}

function showTooltip() {
	var clipButton = document.getElementById("copyLink");
	var tooltip = document.getElementById("myTooltip");
	tooltip.classList.add("showTooltip");
	tooltip.style.left = (clipButton.offsetLeft + 10).toString() + "px";
	tooltip.innerHTML="Copy link to current page";
}

function hideTooltip() {
	var tooltip = document.getElementById("myTooltip");
	tooltip.classList.remove("showTooltip");
}

function setPlaceholder(pText) {
	var ipfield = document.getElementById("searchTerm");
	ipfield.placeholder=pText;
}

//Find the first visible H1, H2 or H3 displayed in the content frame after a scroll event
//Derive a hashtag from the tag's id and use it to locate the <a> tag in the tocFrame
function showTocHiLite(pUrl)
{
	var contentFrame = parent.document.getElementById('contentFRM');
	var content = contentFrame.contentWindow.document;
	var tags = content.querySelectorAll('h1,h2,h3');

	for (var i=0; i<tags.length; i++) {
		var rect = tags[i].getBoundingClientRect();
		if (rect.bottom>=0 && rect.top<= (contentFrame.clientHeight)) {
			var splitUrl = tags[i].baseURI.split(/[\/#]+/); //split on / and #
			var pageName = splitUrl[splitUrl.length-2];
			var hashUrl = pageName + "#" + tags[i].id;

			var hashTag = "#" + tags[i].id;
			var tocFrame = parent.document.getElementById('tocFRM');
			tocFrame.contentWindow.expandTOC(hashTag);

			var urlList = Array.from(tocFrame.contentDocument.getElementsByTagName("A"));
			var aFound = urlList.find(function(element) {
				return element.href.indexOf(hashUrl)>0;
			});

			if (aFound) {
				//move the TOC hilite from previous item to new item
				if (tocHiLite) tocHiLite.style.background="";
				tocHiLite = aFound;
				tocHiLite.style.background="#acf";
				//adjust scroll bar if the new item is not in viewport
				rect = tocHiLite.getBoundingClientRect();
				if (rect.bottom>tocFrame.clientHeight) {
					tocFrame.contentWindow.scrollTo({top: tocFrame.contentWindow.scrollY+36 + rect.top-tocFrame.clientHeight, behavior:'smooth'});
				}
				else if (rect.top < 0) {
				tocFrame.contentWindow.scrollTo({top: tocFrame.contentWindow.scrollY+rect.top-18, behavior:'smooth'});
				}
				//store link to the marked page- in case of copy to clipboard
  				parent.currentPage = parent.location.origin + aFound.href.replace("javascript:load('","");
	  			parent.currentPage = parent.currentPage.replace("')","");
			}
			break;
		}
	}
}

/*Load the requested url into the parent's content iframe*/
function load(url) {
	parent.currentPage = parent.document.URL.substring(0,parent.document.URL.lastIndexOf("/"));
  	parent.currentPage = parent.currentPage.substring(0,parent.currentPage.lastIndexOf("/"));
	parent.currentPage = parent.currentPage.substring(0,parent.currentPage.lastIndexOf("/"));
	parent.currentPage = parent.currentPage.substring(0,parent.currentPage.lastIndexOf("/"));
	parent.currentPage =  parent.currentPage+url; //used by copy-link button
			  
		var a =  parent.document.getElementById('contentFRM');
		var elem = this.parentNode;

		var isScrolling; //used to detect scrolling content

		function chapterFromUrl(theUrl) {
			var hashPos = theUrl.indexOf("#");
			var slashPos = theUrl.lastIndexOf("/") + 1;
			return theUrl.substring(slashPos, hashPos);
		}

		a.onload = function () { //triggered when the html page changes
			setTimeout(function() {
				parent.window.scrollTo(0, 0); // values are x,y-offset
			},0);

			//contentFrame = document.getElementById('contentFRM').contentWindow;
            a.contentWindow.addEventListener('scroll', function ( event ) {
                //Detect when scrolling ends on the content frame so that TOC cursor can be repositioned
                window.clearTimeout( isScrolling );
                isScrolling = setTimeout(function() {
					showTocHiLite(url);
                }, 66);
            }, false);

		};
		a.src = url;

		if (chapterFromUrl(url) == chapterFromUrl(a.src)) {
			setTimeout(function() { //triggered when the anchor name changes
				parent.window.scrollTo(0, -100); // values are x,y-offset
			},100);
		}
	}

      /*Attach a click event to each checkbox field, calls the toggleFunction*/
	function doCheckboxes() {
		var checkBoxes = document.querySelectorAll('input[type=checkbox]');
		var litems = document.querySelectorAll(`[class*="collapsibleListClosed"]`);
		for (var i = 0; i < checkBoxes.length; i++) {
			var origCb = checkBoxes[i];
			var newCb = document.createElement('div');
			newCb.className = "class_checkbox";
			newCb.innerHTML = "&#9660;"; /*"&#9654;"; /* "►"; */
			origCb.parentNode.insertBefore(newCb, origCb);
			origCb.style.display = "none";
		}

		/*Return the input field's label node*/
		function findLabel(inputField) {
			var children = inputField.parentNode.childNodes;
			for (var i = 0; i < children.length; i++) {
				if (children[i].tagName === "LABEL")
					return children[i];
			}
		}
	}

	 /*Get the URL of the current page, then extract the file name and path from the URL*/
	 function getMyName() {
		var URL = unescape(location.href);	// get current URL in plain ASCII
		var xstart = URL.lastIndexOf("/") + 1;
		var xend = 200; //the rest of the line
		var myName;
		if (xend > xstart)
			myName = URL.substring(xstart,xend);
		else
			myName = "overview";
		return myName;
	}

	/////// Manual resize of TOC pane ////////
function setupResize() {
	var widget = document.getElementById('resize');
	var leftPane = document.getElementById('left');
	var rightPane = document.getElementById('right');
	var orgX, deltaX;
	if (widget ) { //elmnt.id + "header"
		// if present, the header is where you move the DIV from:
		widget.onmousedown = dragMouseDown; //elmnt.id + "header"
	}


	function dragMouseDown(e) {
		e = e || window.event;
		e.preventDefault();
		orgX = e.clientX;	// get the mouse cursor position at startup:
		document.onmouseup = closeDragElement;
		document.onmousemove = elementDrag;  // call a function whenever the cursor moves:
	}

	function elementDrag(e) {
		e = e || window.event;
		e.preventDefault();
		var secWidth = document.getElementById("section").clientWidth;

		deltaX = e.clientX - orgX;  // calculate the new cursor position
		if (deltaX<0 && e.clientX<100) return;
		orgX = e.clientX;
		var leftPC = ((leftPane.clientWidth+deltaX)*100)/secWidth;

		leftPane.style.width = leftPC+"%";
		rightPane.style.width = 100-leftPC+"%";
		rightPane.style.left = leftPC+"%";
	}

	function closeDragElement() {
		// stop moving when mouse button is released:
		document.onmouseup = null;
		document.onmousemove = null;
	}
}

function growTOC() {
	var elem = document.getElementById("left");
	var grow = elem.clientWidth === 0;
	 elem.style.transition="width 0.5s ease-in-out";
	 elem.style.width=grow?"80%" : "0";
	 elem.style.opacity=grow?0.9:1;
	 elem = document.getElementById("tocGrowHandle");
	 elem.style.transition="left 0.5s ease-in-out, margin-left 0.5s ease-in-out";
	 elem.style.left=grow?"80%":"0";
	 elem = document.getElementById("growPointer");
	 elem.style.transform=grow?"rotate(180deg)":"rotate(0)";
	 elem = document.getElementById("resize");
	 elem.style.visibility=grow?"hidden":"visible";
}

//Automatically issue a search and highlight when a searchterm is passed from search.jsp
function autoSearch() {
		if (searchTerm.length>0) {
			document.getElementById("searchTerm").value = searchTerm;
			document.getElementById("searchButton").click();
			setTimeout(function() {
				var iframe = document.getElementById("contentFRM");
				var iframeDocument = iframe.contentDocument || iframe.contentWindow.document;
				var myHilitor = new Hilitor(iframeDocument);
				myHilitor.setMatchType("open");
				myHilitor.apply(searchTerm);
			}, 1000);

		}
}